# Lesson 1: Resources and commands. 

## Key Resources

1. [**Aiken Documentation:**](https://aiken-lang.org/installation-instructions) This comprehensive guide walks you through the language, covering its features and providing in-depth tutorials. It also offers a clear explanation of EUTxO in the context of smart contract programming.
2. [**Standard Library API Documentation:**](https://aiken-lang.github.io/stdlib/) The basic modules for working with all the types of the language and smart contract development.
3. [**Prelude API Documentation:**](https://aiken-lang.github.io/prelude/) This resource focuses on the core features of the language.
4. [**Built-ins API Documentation:**](https://aiken-lang.org/uplc/builtins) Discover all the Plutus primitives available for use in Aiken.

While all these resources are valuable, you'll likely find (1) and (2) particularly important for your current learning objectives. 

## The Aiken Playground

If you want to, you can use the the [Aiken Playground](https://play.aiken-lang.org/), its a good place to play with the language without installing anything. 

## Set up: Check if you have the last version installed. 

Check if you have the last released version of Aiken. You can see the last released version [here](https://github.com/aiken-lang/aiken/releases)

```bash
$ aiken --version 
aiken v1.0.16-alpha 1dea348
```

If you haven't the latest version you can upgrade with the following: 

```bash
$ cargo install --git https://github.com/aiken-lang/aiken.git
```

And if for some reason if you don't have Aiken installed, see how to do it in the [installation](https://aiken-lang.org/installation-instructions) section from the docs or see [101.5 module](https://plutuspbl.io/modules/101/1015) .

## Language extension 

Something that will help you a lot is installing the language extension in your code editor, this will show you useful suggestions and compiler messages on live. Now just vs-code, vim and neo-vim are supported, the details are in the end of this [section](https://aiken-lang.org/installation-instructions). 

## Environment & Commands

A quick intro about the most common Aiken commands: **new**, **build** and **check**. Once you have your Aiken installation ready to go, you can start a new project with the  `aiken new` command plus the author name and project name like this: 
```bash
$ aiken new student-name/project-name
```

This will start a new project that will have the following file structure: 

```bash
project-name
├── aiken.toml
├── lib
│   └── project-name
├── README.md
└── validators
```

Let's explain this: 

* **aiken.toml:** This configuration file serves as a project descriptor, detailing the project and listing its dependencies. It plays a crucial role in building validators and managing dependencies.
* **lib/ directory:** Within this directory, you'll store the libraries and modules you use in your project. It's your workspace for organizing reusable code components.
* **validators/ directory:** This directory is where you'll house your validators. As you've noticed, these validator files have the `.ak` extension.
* **README.md**: A read-me file is created automatically.

Unlike older versions, newer version doesn't come with an example validator. We need one to introduce the next commands. Let's copy the dummy contract from the previous module and create a `always-succed.ak` file in the validators folder.

```rust
validator {
  fn always_succeed(_datum: Data, _redeemer: Data, _context: Data) -> Bool {
    True
  }
}
```

Next, execute the `aiken build` command. This command generates a `plutus.json` file, which serves as a specification for your contracts. Inside this file, you'll find a some information, including a contract description, relevant parameters and data types, as well as the compiled code in CBOR format and its corresponding script hash. Take a moment to explore this file and grasp its contents.

In this example, you'll notice that, like all spending validators, the `always succeed` function takes three arguments (or inputs). It unconditionally returns a Boolean value of True, regardless of the parameters provided. Pay attention to the underscores `_` used in the arguments; these instruct the Aiken compiler to disregard them. 

Lastly, there is the `aiken check` command... remove one underscore and execute this command... see what happens! Such a beautiful and annoying compiler message right???! You can use this command to verify the syntax of the code, the type correctness of the functions and execute the unit tests.

## Keep Learning 

Here I leave you some tasks: 

1. **Explore other Aiken commands:** There are some other cool Aiken commands like `docs` or `blueprint`  try to use the `--help` flag and to explore them or others you find interesting. Be curious! 
2. **Study the types and variables section from the maindocumentation:** In the next lesson you will explore some language expressions and features, it will be taken from granted that you have some vague experience with types... but if you don't go to take a look [here](https://aiken-lang.org/language-tour/primitive-types).



import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
